From: Pablo Neira Ayuso <pablo@netfilter.org>
To: netfilter-devel@vger.kernel.org
Subject: [PATCH nft,v2] scanner: handle files with CRLF line terminators
Date: Thu, 8 Dec 2022 02:41:51 +0100 [thread overview]
Message-ID: <20221208014151.529052-1-pablo@netfilter.org> (raw)
Extend scanner.l to deal with CRLF, otherwise -f fails to load:
# file test.nft
test.nft: ASCII text, with CRLF, LF line terminators
# nft -f test.nft
test.nft:1:13-13: Error: syntax error, unexpected junk
table ip x {
^
Update full comment line to take CRLF too.
Add test to cover this usecase.
Signed-off-by: Pablo Neira Ayuso <pablo@netfilter.org>
---
v2: Update comment_line to accept CRLF.
src/scanner.l | 6 ++++--
tests/shell/testcases/nft-f/crlf_0 | 17 +++++++++++++++++
2 files changed, 21 insertions(+), 2 deletions(-)
create mode 100755 tests/shell/testcases/nft-f/crlf_0
diff --git a/src/scanner.l b/src/scanner.l
index e72a427aab48..254a23fb4068 100644
--- a/src/scanner.l
+++ b/src/scanner.l
@@ -113,7 +113,9 @@ extern void yyset_column(int, yyscan_t);
space [ ]
tab \t
-newline \n
+newline_lf \n
+newline_crlf \r\n
+newline ({newline_lf}|{newline_crlf})
digit [0-9]
hexdigit [0-9a-fA-F]
decstring {digit}+
@@ -124,7 +126,7 @@ string ({letter}|[_.])({letter}|{digit}|[/\-_\.])*
quotedstring \"[^"]*\"
asteriskstring ({string}\*|{string}\\\*|\\\*|{string}\\\*{string})
comment #.*$
-comment_line ^[ \t]*#.*\n
+comment_line ^[ \t]*#.*(\r\n|\n)
slash \/
timestring ([0-9]+d)?([0-9]+h)?([0-9]+m)?([0-9]+s)?([0-9]+ms)?
diff --git a/tests/shell/testcases/nft-f/crlf_0 b/tests/shell/testcases/nft-f/crlf_0
new file mode 100755
index 000000000000..7ba785c8656a
--- /dev/null
+++ b/tests/shell/testcases/nft-f/crlf_0
@@ -0,0 +1,17 @@
+#!/bin/bash
+
+set -e
+
+RULESET="table ip foo {\r\n\tchain ber {\r\n\t}\r\n}"
+
+tmpfile=$(mktemp)
+if [ ! -w $tmpfile ] ; then
+ echo "Failed to create tmp file" >&2
+ exit 0
+fi
+
+trap "rm -rf $tmpfile" EXIT # cleanup if aborted
+
+echo -e "$RULESET" > $tmpfile
+
+$NFT -f "$tmpfile"
--
2.30.2
next reply other threads:[~2022-12-08 1:42 UTC|newest]
Thread overview: 2+ messages / expand[flat|nested] mbox.gz Atom feed top
2022-12-08 1:41 Pablo Neira Ayuso [this message]
2022-12-08 21:23 ` [PATCH nft,v2] scanner: handle files with CRLF line terminators Pablo Neira Ayuso
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20221208014151.529052-1-pablo@netfilter.org \
--to=pablo@netfilter.org \
--cc=netfilter-devel@vger.kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.